package bug;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Iterator;
import java.util.regex.Pattern;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFFormulaEvaluator;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;

public class Bug_ParseAddinFormulas {

	public static void main(String[] args) throws Exception {
		POIFSFileSystem fs;
		HSSFWorkbook wb;
		HSSFSheet sheet;
		HSSFCell cell;
		FileOutputStream out;

		fs = new POIFSFileSystem(new FileInputStream("add-in formulas.xls"));		
		wb = new HSSFWorkbook(fs);
		sheet = wb.getSheetAt(0);

		HSSFFormulaEvaluator evaluator = new HSSFFormulaEvaluator(sheet, wb);
		
		// Change formula
		try{
			cell = sheet.getRow(1).getCell(0);
			cell.setCellFormula("SomeAddinFunction(C1)");
		}catch(Exception e){
			System.err.println("exception in setCellFormula, update");
			e.printStackTrace();
		}
		
		// Add new formula
		try{
			cell = sheet.getRow(1).getCell(2);
			cell.setCellFormula("SomeAddinFunction2(C1)");
		}catch(Exception e){
			System.err.println("exception in setCellFormula, insert new");
			e.printStackTrace();
		}
		

		// Evaluate, direct
		try{
			cell = sheet.getRow(1).getCell(4);
			if(cell.getCellType() == HSSFCell.CELL_TYPE_FORMULA) {
			                	evaluator.evaluateFormulaCell(cell);
			}
		}catch(Exception e){
			System.err.println("exception in evaluate, direct");
			e.printStackTrace();
		}

		// Evaluate, referenced
		try{
			cell = sheet.getRow(2).getCell(6);
			if(cell.getCellType() == HSSFCell.CELL_TYPE_FORMULA) {
			                	evaluator.evaluateFormulaCell(cell);
			}
		}catch(Exception e){
			System.err.println("exception in evaluate, reference");
			e.printStackTrace();
		}


		
		out = new FileOutputStream("add-in formulas out.xls");
		wb.write(out);
		out.close();

		System.out.println("done");
		
	}
	
}
